<?php
/*
+----------------------------------------------------------------+
|																 |
|	WordPress 2.8 Plugin: WP-PhotoContest 1.0                    |
|	Copyright (c) 2009 Frank van der Stad						 |
|																 |
|	File Written By:											 |
|	- Frank van der Stad										 |
|	- http://www.vanderstad.nl/wp-photocontest									 |
|																 |
|	File Information:											 |
|	- Add PhotoContest											 |
|	- wp-content/plugins/wp-photocontest/photocontest-add.php	 |
|																 |
+----------------------------------------------------------------+
*/


### Check Whether User Can Manage PhotoContest
if(!current_user_can('manage_photocontest')) {
	die('Access Denied');
}

$wpdb->hide_errors();
if (DEBUG_FLAG == 1)
{
	error_reporting(E_ALL);
	if (!ini_get("display_errors") || ini_get("display_errors")==0)
	{
		ini_set("display_errors", 1);
	} 
	$wpdb->show_errors();
}

### PhotoContest Manager
$base_name = plugin_basename('wp-photocontest/photocontest-manager.php');
$base_page = 'admin.php?page='.$base_name;

### Add the lib classes
require_once(dirname(__FILE__).'/lib/wp-photocontest.functions.php');
require_once(dirname(__FILE__).'/lib/wp-photocontest.class.php');
require_once(dirname(__FILE__).'/lib/debug.func.php');

### Variables
$checkArray = 	array(
					"do"=>"",
					"photocontest_new"=>"",
					"photocontest_init_day"=>"",
					"photocontest_end_day"=>"",
					"photocontest_end_upload"=>"",
					"photocontest_contest_name"=>"",
					"photocontest_intro_text"=>"",
					"photocontest_max_photos"=>""
				);

$_REQUEST = array_merge($checkArray,$_REQUEST);

$action						= wppc_checkOptions($_REQUEST['do'],array(__('Add PhotoContest', 'wp-photocontest')));
$photocontest_new 			= wppc_checkInteger($_REQUEST['photocontest_new']);
$photocontest_init_day 		= wppc_checkValidDate($_REQUEST['photocontest_init_day'],date('Y-m-d'));
$photocontest_end_day 		= wppc_checkValidDate($_REQUEST['photocontest_end_day'],date('Y-m-d', strtotime('+1 week')));
$photocontest_end_upload	= wppc_checkValidDate($_REQUEST['photocontest_end_upload'],date('Y-m-d', strtotime('+1 week')));
$photocontest_contest_name	= wppc_checkString($_REQUEST['photocontest_contest_name']);
$photocontest_intro_text	= wppc_checkString($_REQUEST['photocontest_intro_text'],'');
$photocontest_max_photos	= wppc_checkInteger($_REQUEST['photocontest_max_photos'],1);

### Add some vars
$show_form 		= true;


### Form Processing 
if(!empty($action)) {
	// Decide What To Do
	switch($action) {
		// Add PhotoContest
		case __('Add PhotoContest', 'wp-photocontest'):
			// Check if contest name is set
			if (!$photocontest_contest_name)
			{
				$text .= '<p style="color: red;">'.sprintf(__('Error in adding PhotoContest \'%s\'.', 'wp-photocontest'), stripslashes($photocontest_contest_name)).'</p>';
				$text .= '<p style="color: red;">'.__('You have not provided a contest name', 'wp-photocontest').'</p>';
				break;	
			}
					
			// Check if the dates are entered correctly
			if (!$photocontest_init_day) 
			{
				$text .= '<p style="color: red;">'.sprintf(__('Error in adding PhotoContest \'%s\'.', 'wp-photocontest'), stripslashes($photocontest_contest_name)).'</p>';
				$text .= '<p style="color: red;">'.__('Invalid startdate.', 'wp-photocontest').'</p>';
				break;		
			}
			// Check if the dates are entered correctly
			if (!$photocontest_end_day) 
			{
				$text .= '<p style="color: red;">'.sprintf(__('Error in adding PhotoContest \'%s\'.', 'wp-photocontest'), stripslashes($photocontest_contest_name)).'</p>';
				$text .= '<p style="color: red;">'.__('Invalid enddate.', 'wp-photocontest').'</p>';
				break;		
			}
			// Check if the dates are entered correctly
			if (!$photocontest_end_upload) 
			{
				$text .= '<p style="color: red;">'.sprintf(__('Error in adding PhotoContest \'%s\'.', 'wp-photocontest'), stripslashes($photocontest_contest_name)).'</p>';
				$text .= '<p style="color: red;">'.__('Invalid end upload date.', 'wp-photocontest').'</p>';
				break;		
			}						
			
			$photocontest_index_path = wppc_strNormalizeName($photocontest_contest_name);
						
			// Check if directory doesn't conflict with existing dirs/files
			if (! wppc_isRightDir($photocontest_index_path))
			{
				$text .= '<p style="color: red;">'.sprintf(__('Error in checking PhotoContest directory \'%s\'.', 'wp-photocontest'), stripslashes($photocontest_contest_name)).'</p>';
				$text .= '<p style="color: red;">'.__('This name is invalid, choose an other name', 'wp-photocontest').'</p>';
				break;	
			}
			
			// Check if directory exists
			if (file_exists(dirname(__FILE__)."/".CONTESTS_PATH."/".$photocontest_index_path))
			{
				$text .= '<p style="color: red;">'.sprintf(__('Error in checking PhotoContest directory \'%s\'.', 'wp-photocontest'), stripslashes($photocontest_contest_name)).'</p>';
				$text .= '<p style="color: red;">'.__('There is already a contest with this name, choose an other name', 'wp-photocontest').'</p>';
				break;		
			}			
			
			// Create upload directory
			$photo_directory=dirname(__FILE__)."/".CONTESTS_PATH."/".$photocontest_index_path;
			umask('000');
			if (!$mkdir_result = mkdir($photo_directory))
			{
				$text .= '<p style="color: red;">'.sprintf(__('Error in checking PhotoContest directory \'%s\'.', 'wp-photocontest'), stripslashes($photocontest_contest_name)).'</p>';
				$text .= '<p style="color: red;">'.__('Can\'t create the directory:', 'wp-photocontest').' '.$photo_directory.'</p>';
				$text .= '<p style="color: red;"><pre>'.$mkdir_result.'</pre></p>';				
				break;		
			}				
						
			// Create a new page
			// create post object
			class wm_mypost {
				var $post_title;
				var $post_content;
				var $post_status;
				var $post_author;    		/* author user id (optional) */
				var $post_name;				/* slug (optional) */
				var $post_type;				/* 'page' or 'post' (optional, defaults to 'post') */
				var $comment_status;		/* open or closed for commenting (optional) */
			}
			// initialize post object
			$wm_mypost = new wm_mypost();
			
			// fill object
			$photocontestPage = new photoContest();
			$photocontestPage->setInitHtml($photocontest_intro_text);
			
			$wm_mypost->post_title		= $photocontest_contest_name;
			$wm_mypost->post_content	= $photocontestPage->getInitHtml();
			$wm_mypost->post_status		= DEFAULT_STATUS;
			$wm_mypost->post_author		= DEFAULT_UID;
			$wm_mypost->post_name 		= DEFAULT_PAGENAME;			
			$wm_mypost->post_type		= DEFAULT_TYPE;
			$wm_mypost->comment_status	= DEFAULT_STATUS;
			
			// feed object to wp_insert_post
			$photocontestPostID = wp_insert_post($wm_mypost);

			// Add an link to Enter the contest
			$wm_mypost->post_content .= "<BR /><p><a href=\"".get_option('siteurl')."/wp-content/plugins/wp-photocontest/view.php?post_id=".$photocontestPostID."\">";
			$wm_mypost->post_content .= __('Enter the Contest', 'wp-photocontest');
			$wm_mypost->post_content .= "</a></p>";

			//Save the ID			
			$wm_mypost->ID	= $photocontestPostID;

			//Update the post
			wp_update_post($wm_mypost);
			
			//Enter the data into the photocontest_admin table		
			//$wpdb->show_errors();
			$new_contest_id = $wpdb->insert
			(
				$wpdb->prefix.'photocontest_admin',
				array(
					'post_id' => $photocontestPostID,
					'start_date' => $photocontest_init_day,
					'end_date' => $photocontest_end_day,
					'upload_date' => $photocontest_end_upload,
					'contest_path' => $photocontest_index_path,
					'contest_name' => $photocontest_contest_name,
					'intro_text' => $photocontest_intro_text,
					'num_photo' => 0,
					'max_photos' => $photocontest_max_photos
				), 
				array(
					'%d', '%s', '%s', '%s', '%s', '%s', '%s', '%d', '%d'
				)
			);		

			if ($new_contest_id)
			{
				$text .= '<p style="color: green;">'.sprintf(__('Succes saving PhotoContest \'%s\'.', 'wp-photocontest'), stripslashes($photocontest_contest_name)).'</p>';
				$text .= '<p style="color: green;"><a href="'.$base_page.'">'.__('Click here to continue', 'wp-photocontest').'</a></p>';
				$show_form = false;
			}
			else
			{
				//TODO: Rollback of directory and page
				$text .= '<p style="color: red;">'.sprintf(__('Error saving PhotoContest \'%s\'.', 'wp-photocontest'), stripslashes($photocontest_contest_name)).'</p>';
				$text .= '<p style="color: red;">'.__('Can\'t insert into the database', 'wp-photocontest').'</p>';
				$text .= '<p style="color: red;">'.wppc_printDatabaseError().'</p>';
				$show_form = false;			
			}
			
		break;
		
		default:
			// We don't have a valid action. Just show the add-form
		break;	
	}
}	


photocontest_scripts_and_styles();
?>
<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=<?php echo plugin_basename(__FILE__); ?>">
<div class="wrap">
<?php
### Add PhotoContest Form
if(!empty($text)) { 
	echo '<!-- Last Action --><div id="message" class="updated fade">'.stripslashes($text).'</div>';
}
?>

<?php
if ($show_form)
{
?>
	<div id="icon-wp-photocontest" class="icon32"><br /></div>
	<h2><?php _e('Add Contest', 'wp-photocontest'); ?></h2>
	<!-- Contest info -->
	<h3><?php _e('Details', 'wp-photocontest'); ?></h3>
	<table class="form-table">
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('Name', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<input name="photocontest_contest_name" type="text" width="100" value="<?php echo $photocontest_contest_name;?>">
			  	<br />
				<?php _e('Enter the title you give to this contest.', 'wp-photocontest');?>
				<?php _e('(this field will also be the path of the photos for the competition).', 'wp-photocontest');?>
			</td>
		</tr>
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('Photos by user', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<input name="photocontest_max_photos" type="text" width="10" value="<?php echo $photocontest_max_photos;?>">
				<br /><?php _e('Enter the maximum number of photos that a user can upload.', 'wp-photocontest');?>
				<br/><?php _e('If you leave this empty, it will set 1 by default.', 'wp-photocontest');?>
			</td>
		</tr>
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('Introduction text', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<textarea rows="6" cols="40" name="photocontest_intro_text"><?php echo $photocontest_intro_text;?></textarea>
				<br/>
				<?php _e('Enter the initial content of the page as an introduction.', 'wp-photocontest') ?><br />
				<?php _e('To format the content in this textarea field, enter HTML tags.', 'wp-photocontest');?><br />
				<?php _e('Don\'t use the following tags', 'wp-photocontest');?>
				<UL>
					<LI><strong>HTML</strong></LI>
					<LI><strong>HEAD</strong></LI>
					<LI><strong>BODY</strong></LI>
				</UL>
			</td>
		</tr>		
	</table>
	<!-- Contest dates -->
	<h3><?php _e('Dates', 'wp-photocontest'); ?></h3>
	<table class="form-table">
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('Startdate', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<input type="text" name="photocontest_init_day" id="photocontest_init_day" size="30" value="<?php echo $photocontest_init_day;?>"><input type="reset" value=" ... " onclick="return showCalendar('photocontest_init_day', '%Y-%m-%d');">
				<br /><?php _e('Choose the date on which you want the contest to begin.', 'wp-photocontest');?>
			</td>
		</tr>
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('Enddate', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<input type="text" name="photocontest_end_day" id="photocontest_end_day" size="30" value="<?php echo $photocontest_end_day;?>"><input type="reset" value=" ... " onclick="return showCalendar('photocontest_end_day', '%Y-%m-%d');">
				<br /><?php _e('Enter the date for the contest.', 'wp-photocontest');?>
			</td>
		</tr>
		<tr>
			<th width="20%" scope="row" valign="top"><?php _e('End upload date', 'wp-photocontest') ?>:</th>
			<td width="80%">
				<input type="text" name="photocontest_end_upload" id="photocontest_end_upload" size="30" value="<?php echo $photocontest_end_upload;?>"><input type="reset" value=" ... " onclick="return showCalendar('photocontest_end_upload', '%Y-%m-%d');">
				<br /><?php _e('Enter the latest date allowed to upload photos.', 'wp-photocontest');?>
			</td>
		</tr>		
	</table>
	<p style="text-align: center;"><input type="submit" name="do" value="<?php _e('Add PhotoContest', 'wp-photocontest'); ?>"  class="button" />&nbsp;&nbsp;<input type="button" name="cancel" value="<?php _e('Cancel', 'wp-photocontest'); ?>" class="button" onclick="javascript:history.go(-1)" /></p>
<?php
}
?>
</div>
</form>